'
'   Version 2.1 April 2019 
'       Fix Real Com Ports with CM109
'
Imports System
Imports System.IO
Imports System.Threading

Imports HidLibrary


Public Class Form1

    Private Const GENERIC_WRITE As UInteger = &H40000000
    Private Const GENERIC_READ As Long = &H80000000
    Private Const GENERIC_RW As Long = &H10000000

    Private Const FILE_ATTRIBUTE_NORMAL As UInteger = &H80
    Private Const CREATE_ALWAYS As UInteger = 2
    Private Const OPEN_ALWAYS As UInteger = 4
    Private Const INVALID_HANDLE_VALUE As Long = -1
    Const OPEN_EXISTING As UInteger = 3
    Const FILE_SHARE_READ As UInteger = &H1
    Const FILE_SHARE_WRITE As UInteger = &H2
    Const FILE_FLAG_NO_BUFFERING As UInteger = &H20000000

    Const FILE_DEVICE_SERIAL_PORT As UInteger = &H1B
    Const METHOD_BUFFERED As UInteger = 0
    Const FILE_ANY_ACCESS As UInteger = 0

    Const IOCTL_SERIAL_IS_COM_OPEN As UInteger = FILE_DEVICE_SERIAL_PORT << 16 Or &H800 << 2
    Const IOCTL_SERIAL_GETDATA As UInteger = (FILE_DEVICE_SERIAL_PORT << 16) Or (&H801 << 2)
    Const IOCTL_SERIAL_SETDATA As UInteger = (FILE_DEVICE_SERIAL_PORT << 16) Or (&H802 << 2)

    Private Declare Function CloseHandle Lib "kernel32" _
    (ByVal hObject As Long) As Long

    Private Declare Function WriteFile Lib "kernel32" _
       (ByVal hFile As Long, ByVal lpBuffer As String,
       ByVal nNumberOfBytesToWrite As Long,
       ByVal lpNumberOfBytesWritten As Long,
       ByVal lpOverlapped As Long) As Long

    Private Declare Function ReadFile Lib "kernel32" _
       (ByVal hFile As Long, ByRef lpBuffer As String,
       ByVal nNumberOfBytesToRead As Long,
       ByRef lpNumberOfBytesRead As Long,
       ByVal lpOverlapped As Long) As Long


    Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" _
       (ByVal lpFileName As String,
       ByVal dwDesiredAccess As UInteger,
       ByVal dwShareMode As UInteger,
       ByVal lpSecurityAttributes As UInteger,
       ByVal dwCreationDisposition As UInteger,
       ByVal dwFlagsAndAttributes As UInteger,
       ByVal hTemplateFile As UInteger) As IntPtr

    Private Declare Function DeviceIoControl Lib "kernel32" (ByVal hDevice As UInteger, ByVal dwIoControlCode As UInteger,
       ByVal lpInBuffer As String, ByVal nInBufferSize As Integer, ByVal lpOutBuffer As String,
       ByVal nOutBufferSize As Integer, ByRef lpBytesReturned As Integer, ByVal lpOverlapped As UInteger) As UInteger

    <System.Runtime.InteropServices.DllImport("c:\devprogs\bpq32\hidapi.dll")>
    Public Shared Function hid_set_ptt(ByVal state As Integer) As Integer
    End Function

    Dim StopThread As Boolean
    Dim PTTState As Boolean
    Dim sr1 As FileStream
    Dim sr2 As FileStream
    Dim sr3 As FileStream
    Dim sr4 As FileStream
    Dim myHandle As IntPtr
    Dim myHandle2 As IntPtr
    Dim myHandle3 As IntPtr
    Dim myHandle4 As IntPtr
    Dim TXMsg(10) As Byte
    Dim RXMsg(10) As Byte
    Dim Buffer1(100) As Byte
    Dim Buffer2(100) As Byte
    Dim Buffer3(100) As Byte
    Dim Buffer4(100) As Byte

    ' For CM108

    Dim _devices As IEnumerable(Of HidDevice)
    Dim _device As HidDevice
    Dim info(5) As Byte
    Dim HidPin As Integer = 3
    Dim VIDVal As Integer = &HD8C
    Dim PIDVal As Integer = 8



    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        SetPTT(0)

        My.Settings.VID = VID.Text
        My.Settings.PID = PID.Text


    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim i As Integer
        Dim Args As System.Collections.ObjectModel.ReadOnlyCollection(Of String) = My.Application.CommandLineArgs

        info(0) = 0
        info(1) = 0
        info(2) = 1 << (HidPin - 1)
        info(4) = 0

        If My.Computer.Ports.SerialPortNames.Count < 2 Then
            MsgBox("Less than 2 serial ports found", MsgBoxStyle.Critical)
            End
        End If

        RemoteCOM.Items.Insert(0, "None")
        RemoteCOM2.Items.Insert(0, "None")
        RemoteCOM3.Items.Insert(0, "None")
        RemoteCOM4.Items.Insert(0, "None")

        For Each sp As String In My.Computer.Ports.SerialPortNames
            LocalCOM.Items.Insert(0, sp)
            RemoteCOM.Items.Insert(0, sp)
            RemoteCOM2.Items.Insert(0, sp)
            RemoteCOM3.Items.Insert(0, sp)
            RemoteCOM4.Items.Insert(0, sp)
        Next

        LocalCOM.Items.Insert(0, "CM108")


        LocalCOM.SelectedIndex = LocalCOM.FindStringExact(My.Settings.LocalCOM)
        RemoteCOM.SelectedIndex = RemoteCOM.FindStringExact(My.Settings.RemoteCOM)
        RemoteCOM2.SelectedIndex = RemoteCOM.FindStringExact(My.Settings.RemoteCOM2)
        RemoteCOM3.SelectedIndex = RemoteCOM.FindStringExact(My.Settings.RemoteCOM3)
        RemoteCOM4.SelectedIndex = RemoteCOM.FindStringExact(My.Settings.RemoteCOM4)
        IgnoreRTS.Checked = My.Settings.IgnoreRTS

        LocallBaud.Items.Add("115200")
        LocallBaud.Items.Add("57600")
        LocallBaud.Items.Add("38400")
        LocallBaud.Items.Add("19200")
        LocallBaud.Items.Add("9600")
        LocallBaud.Items.Add("4800")
        LocallBaud.Items.Add("2400")
        LocallBaud.Items.Add("1200")

        LocallBaud.SelectedIndex = LocallBaud.FindString(My.Settings.LocalBaud)
        CatPort.BaudRate = My.Settings.LocalBaud
        CatPort.PortName = My.Settings.LocalCOM

        For i = 0 To 255
            If (i > 15) Then
                ICOMAddr.Items.Add(Hex(i))
            Else
                ICOMAddr.Items.Add("0" & Hex(i))
            End If
        Next

        ICOMAddr.SelectedIndex = ICOMAddr.FindString(My.Settings.ICOMAddr)

        VID.Text = My.Settings.VID
        PID.Text = My.Settings.PID

        ' If command line args present, use them

        If Args.Count = 4 Then
            RemoteCOM.SelectedIndex = RemoteCOM.FindStringExact(Args(0).ToUpper)
            LocalCOM.SelectedIndex = LocalCOM.FindStringExact(Args(1).ToUpper)
            LocallBaud.SelectedIndex = LocallBaud.FindString(Args(2).ToUpper)
            ICOMAddr.SelectedIndex = ICOMAddr.FindString(Args(3).ToUpper)
        End If

        TX.Visible = False
        RX.Visible = True
        TX2.Visible = False
        RX2.Visible = True
        TX3.Visible = False
        RX3.Visible = True
        TX4.Visible = False
        RX4.Visible = True

        Control.CheckForIllegalCrossThreadCalls = False

        TXMsg(0) = &HFE
        TXMsg(1) = &HFE
        TXMsg(2) = Convert.ToInt32(ICOMAddr.SelectedItem, 16)  ' Rig address
        TXMsg(3) = &HE0
        TXMsg(4) = &H1C   ' RIG STATE
        TXMsg(5) = &H0    ' PTT
        TXMsg(6) = 1      ' PTT On
        TXMsg(7) = &HFD

        RXMsg(0) = &HFE
        RXMsg(1) = &HFE
        RXMsg(2) = Convert.ToInt32(ICOMAddr.SelectedItem, 16)  ' Rig address
        RXMsg(3) = &HE0
        RXMsg(4) = &H1C   ' RIG STATE
        RXMsg(5) = &H0    ' PTT
        RXMsg(6) = 0      ' PTT Off
        RXMsg(7) = &HFD

        '       hid_set_ptt(1)

        '      hid_set_ptt(0)

        If Args.Count = 4 Or (Args.Count = 1 AndAlso Args(0).ToUpper = "START") Then

            OpenPorts()

        End If

    End Sub

    Private Sub Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Open.Click

        OpenPorts()

    End Sub

    Private Sub OpenPorts()

        Dim n As Integer = 0

        If CatPort.PortName = "CM108" Then

            Try

                VIDVal = Convert.ToInt32(VID.Text, 16)
                PIDVal = Convert.ToInt32(PID.Text, 16)

            Catch ex As Exception

                MsgBox("VID or PID invalid")
                Exit Sub


            End Try

            My.Settings.VID = VID.Text
            My.Settings.PID = PID.Text

            _devices = HidDevices.Enumerate(VIDVal, PIDVal)

            ' Check how many returned

            For Each _device In _devices
                n += 1
            Next

            If n = 0 Then
                MsgBox("No devices found with VID = " & Hex(VIDVal) & " PID = " & Hex(PIDVal))
                Exit Sub
            End If

            If n > 1 Then
                MsgBox("More than one device found with VI D= " & Hex(VIDVal) & " PID = " & Hex(PIDVal) & " - using first")
            End If

            For Each _device In _devices
                _device.OpenDevice()
                Exit For
            Next

            If _device Is Nothing Then
                MsgBox("Failed to open Device VI D= " & Hex(VIDVal) & " PID = " & Hex(PIDVal))
                Exit Sub
            End If

        Else
                CatPort.Close()
            CatPort.Open()
        End If

        SetPTT(0)

        If myHandle.ToInt32 Or myHandle2.ToInt32 Or myHandle3.ToInt32 Or myHandle4.ToInt32 Then
            MsgBox("Ports are already open", MsgBoxStyle.Information)
            Exit Sub
        End If

        Dim Access As ULong = &HC000000
        Dim PortNum As String = Mid$(RemoteCOM.SelectedItem, 4)
        Dim PortName As String = "\\.\pipe\BPQCOM" & PortNum

        Dim tempState1 As Object = 99
        Dim tempState2 As Object = 99
        Dim tempState3 As Object = 99
        Dim tempState4 As Object = 99

        myHandle = CreateFile(PortName, Access * 16, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)

        If (myHandle = &HFFFFFFFF) Then

            ' May be real port

            myHandle = 0

            SerialPort1.Close()
            SerialPort1.PortName = My.Settings.RemoteCOM
            SerialPort1.Open()

            RX.BackColor = Color.Lime

        Else
            sr1 = New FileStream(myHandle, FileAccess.ReadWrite)
            asyncResult1 = sr1.BeginRead(Buffer1, 0, 2, AddressOf MyCallback1, tempState1)
            RX.BackColor = Color.Lime
        End If

        If RemoteCOM2.SelectedItem <> "None" Then

            PortNum = Mid$(RemoteCOM2.SelectedItem, 4)
            PortName = "\\.\pipe\BPQCOM" & PortNum

            myHandle2 = CreateFile(PortName, Access * 16, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)

            If (myHandle2 = &HFFFFFFFF) Then

                ' May be real port

                myHandle = 0

                SerialPort2.Close()
                SerialPort2.PortName = My.Settings.RemoteCOM2
                SerialPort2.Open()

                RX2.BackColor = Color.Lime

            Else
                sr2 = New FileStream(myHandle2, FileAccess.ReadWrite)
                asyncResult2 = sr2.BeginRead(Buffer2, 0, 2, AddressOf MyCallback2, tempState2)
                RX2.BackColor = Color.Lime
            End If

        End If

        If RemoteCOM3.SelectedItem <> "None" Then

            PortNum = Mid$(RemoteCOM3.SelectedItem, 4)
            PortName = "\\.\pipe\BPQCOM" & PortNum

            myHandle3 = CreateFile(PortName, Access * 16, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)

            If (myHandle3 = &HFFFFFFFF) Then

                ' May be real port

                myHandle = 0

                SerialPort3.Close()
                SerialPort3.PortName = My.Settings.RemoteCOM3
                SerialPort3.Open()

                RX3.BackColor = Color.Lime
            Else
                sr3 = New FileStream(myHandle3, FileAccess.ReadWrite)
                asyncResult3 = sr3.BeginRead(Buffer3, 0, 2, AddressOf MyCallback3, tempState3)
                RX3.BackColor = Color.Lime
            End If
        End If

        If RemoteCOM4.SelectedItem <> "None" Then

            PortNum = Mid$(RemoteCOM4.SelectedItem, 4)
            PortName = "\\.\pipe\BPQCOM" & PortNum

            myHandle4 = CreateFile(PortName, Access * 16, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
            If (myHandle4 = &HFFFFFFFF) Then

                ' May be real port

                myHandle = 0

                SerialPort4.Close()
                SerialPort4.PortName = My.Settings.RemoteCOM4
                SerialPort4.Open()
                n = SerialPort4.CtsHolding

                RX4.BackColor = Color.Lime

            Else
                sr4 = New FileStream(myHandle4, FileAccess.ReadWrite)
                asyncResult4 = sr4.BeginRead(Buffer4, 0, 2, AddressOf MyCallback4, tempState4)
                RX4.BackColor = Color.Lime
            End If

        End If

        Open.Enabled = False

    End Sub

    Dim asyncResult1 As IAsyncResult
    Dim asyncResult2 As IAsyncResult
    Dim asyncResult3 As IAsyncResult
    Dim asyncResult4 As IAsyncResult

    ' Asynchronous Callback method.
    Private Sub MyCallback1(ByVal asyncResult1 As IAsyncResult)
        ' Obtains the last parameter of the delegate call.
        Dim value As Integer = Convert.ToInt32(asyncResult1.AsyncState)
        Dim NewPTT As Boolean
        Dim count As Integer
        Dim tempState As Object = 99


        count = sr1.EndRead(asyncResult1)

        'Debug.Print(Buffer1(0) & " " & Buffer1(1))
        '       Console.WriteLine(Buffer(0) & " " & Buffer(1))




        If Buffer1(0) = 255 Then

            If RadioButton1.Checked = False OrElse IgnoreRTS.Checked = False Then

                If Buffer1(1) And 2 Then
                    NewPTT = True
                Else
                    NewPTT = False
                End If

                If NewPTT <> PTTState Then

                    PTTState = NewPTT

                    If PTTState Then
                        SetPTT(PTTState)
                        TX.Visible = True
                        RX.Visible = False
                    Else
                        TX.Visible = False
                        RX.Visible = True
                        SetPTT(PTTState)
                    End If
                End If
            End If

        Else
            '
            ' Send to Rig Port if selected for CAT control

            If RadioButton1.Checked Then CatPort.Write(Buffer1, 0, count)

        End If

        asyncResult1 = sr1.BeginRead(Buffer1, 0, 2, AddressOf MyCallback1, tempState)


    End Sub 'MyCallback  

    Private Sub MyCallback2(ByVal asyncResult2 As IAsyncResult)
        ' Obtains the last parameter of the delegate call.
        Dim value As Integer = Convert.ToInt32(asyncResult2.AsyncState)
        Dim NewPTT As Boolean
        Dim count As Integer
        Dim tempState As Object = 99

        count = sr2.EndRead(asyncResult2)

        '  Debug.Print(Buffer2(0) & " " & Buffer2(1))
        '       Console.WriteLine(Buffer(0) & " " & Buffer(1))

        If RadioButton2.Checked = False OrElse IgnoreRTS.Checked = False Then

            If Buffer2(0) = 255 Then

                If Buffer2(1) And 2 Then
                    NewPTT = True
                Else
                    NewPTT = False
                End If

                If NewPTT <> PTTState Then

                    PTTState = NewPTT

                    If PTTState Then
                        SetPTT(PTTState)
                        TX2.Visible = True
                        RX2.Visible = False
                    Else
                        TX2.Visible = False
                        RX2.Visible = True
                        SetPTT(PTTState)
                    End If
                End If
            Else
                '
                ' Send to Rig Port if selected for CAT control

                If RadioButton2.Checked Then CatPort.Write(Buffer2, 0, count)

            End If

        End If

        asyncResult2 = sr2.BeginRead(Buffer2, 0, 2, AddressOf MyCallback2, tempState)

    End Sub

    Private Sub MyCallback3(ByVal asyncResult3 As IAsyncResult)
        ' Obtains the last parameter of the delegate call.
        Dim value As Integer = Convert.ToInt32(asyncResult3.AsyncState)
        Dim NewPTT As Boolean
        Dim count As Integer
        Dim tempState As Object = 99

        count = sr3.EndRead(asyncResult3)

        'Debug.Print(Buffer3(0) & " " & Buffer3(1))
        '       Console.WriteLine(Buffer(0) & " " & Buffer(1))

        If RadioButton3.Checked = False OrElse IgnoreRTS.Checked = False Then

            If Buffer3(0) = 255 Then

                If Buffer3(1) And 2 Then
                    NewPTT = True
                Else
                    NewPTT = False
                End If

                If NewPTT <> PTTState Then

                    PTTState = NewPTT

                    If PTTState Then
                        SetPTT(PTTState)
                        TX3.Visible = True
                        RX3.Visible = False
                    Else
                        TX3.Visible = False
                        RX3.Visible = True
                        SetPTT(PTTState)
                    End If
                End If

            Else
                '
                ' Send to Rig Port if selected for CAT control

                If RadioButton3.Checked Then CatPort.Write(Buffer3, 0, count)

            End If

        End If

        asyncResult3 = sr3.BeginRead(Buffer3, 0, 2, AddressOf MyCallback3, tempState)


    End Sub

    Private Sub MyCallback4(ByVal asyncResult4 As IAsyncResult)
        ' Obtains the last parameter of the delegate call.
        Dim value As Integer = Convert.ToInt32(asyncResult4.AsyncState)
        Dim NewPTT As Boolean
        Dim count As Integer
        Dim tempState As Object = 99

        count = sr4.EndRead(asyncResult4)

        'Debug.Print(Buffer4(0) & " " & Buffer4(1))
        '       Console.WriteLine(Buffer(0) & " " & Buffer(1))

        If RadioButton4.Checked = False OrElse IgnoreRTS.Checked = False Then

            If Buffer4(0) = 255 Then

                If Buffer4(1) And 2 Then
                    NewPTT = True
                Else
                    NewPTT = False
                End If

                If NewPTT <> PTTState Then

                    PTTState = NewPTT

                    If PTTState Then
                        SetPTT(PTTState)
                        TX4.Visible = True
                        RX4.Visible = False
                    Else
                        TX4.Visible = False
                        RX4.Visible = True
                        SetPTT(PTTState)
                    End If
                End If

            Else
                '
                ' Send to Rig Port if selected for CAT control

                If RadioButton4.Checked Then CatPort.Write(Buffer4, 0, count)

            End If

        End If

        asyncResult4 = sr4.BeginRead(Buffer4, 0, 2, AddressOf MyCallback4, tempState)


    End Sub


    Private Sub LocalCOM_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LocalCOM.SelectedIndexChanged

        My.Settings.LocalCOM = LocalCOM.SelectedItem
        If CatPort.IsOpen Then Exit Sub
        CatPort.PortName = My.Settings.LocalCOM
        If CatPort.PortName = "CM108" Then
            LocallBaud.Visible = False
            ICOMAddr.Visible = False
            VID.Visible = True
            VIDLabel.Visible = True
            PID.Visible = True
            PIDLabel.Visible = True
        Else
            LocallBaud.Visible = True
            ICOMAddr.Visible = True
            VID.Visible = False
            VIDLabel.Visible = False
            PID.Visible = False
            PIDLabel.Visible = False
        End If


    End Sub

    Private Sub LocallBaud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LocallBaud.SelectedIndexChanged

        My.Settings.LocalBaud = LocallBaud.SelectedItem
        CatPort.BaudRate = LocallBaud.SelectedItem

    End Sub

    Private Sub ICOMAddr_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ICOMAddr.SelectedIndexChanged

        My.Settings.ICOMAddr = ICOMAddr.SelectedItem

        TXMsg(2) = Convert.ToInt32(ICOMAddr.SelectedItem, 16)  ' Rig address
        RXMsg(2) = Convert.ToInt32(ICOMAddr.SelectedItem, 16)  ' Rig address

    End Sub

    Private Sub CatPort_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles CatPort.DataReceived

        Dim len As Integer
        Dim LastLen As Integer = CatPort.BytesToRead
waitloop:
        Thread.Sleep(10)
        len = CatPort.BytesToRead
        If len > LastLen Then
            LastLen = len
            GoTo waitloop
        End If

        Dim Msg(len - 1) As Byte
        Dim i As Integer

        For i = 0 To len - 1
            Msg(i) = CatPort.ReadByte
        Next

        ' If CAT Passthrough selected, send it

        If RadioButton1.Checked Then
            sr1.Write(Msg, 0, len)
        Else
            If RadioButton2.Checked Then
                sr2.Write(Msg, 0, len)
            Else
                If RadioButton3.Checked Then
                    sr3.Write(Msg, 0, len)
                Else
                    If RadioButton4.Checked Then
                        sr4.Write(Msg, 0, len)
                    End If
                End If
            End If

        End If

    End Sub

    Private Sub CloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

        CatPort.Close()

        If myHandle Then
            sr1.Close()
            CloseHandle(myHandle)
        End If

        If myHandle2 Then
            sr2.Close()
            CloseHandle(myHandle2)
        End If

        If myHandle3 Then
            sr3.Close()
            CloseHandle(myHandle3)
        End If

        If myHandle4 Then
            sr4.Close()
            CloseHandle(myHandle4)
        End If



    End Sub


    Private Sub RemoteCOM_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoteCOM.SelectedIndexChanged

        My.Settings.RemoteCOM = RemoteCOM.SelectedItem

    End Sub

    Private Sub RemoteCOM2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoteCOM2.SelectedIndexChanged

        My.Settings.RemoteCOM2 = RemoteCOM2.SelectedItem

    End Sub

    Private Sub RemoteCOM3_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoteCOM3.SelectedIndexChanged

        My.Settings.RemoteCOM3 = RemoteCOM3.SelectedItem

    End Sub

    Private Sub RemoteCOM4_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoteCOM4.SelectedIndexChanged

        My.Settings.RemoteCOM4 = RemoteCOM4.SelectedItem

    End Sub

    Private Sub IgnoreRTS_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles IgnoreRTS.CheckedChanged

        My.Settings.IgnoreRTS = IgnoreRTS.Checked

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Test.Click

        SetPTT(1)
        TX2.Visible = True
        RX2.Visible = False

        Thread.CurrentThread.Sleep(1000)

        TX2.Visible = False
        RX2.Visible = True
        SetPTT(0)

    End Sub



    Private Sub SerialPort1_PinChanged(ByVal sender As Object, ByVal e As System.IO.Ports.SerialPinChangedEventArgs) Handles SerialPort1.PinChanged

        Dim NewPTT As Boolean

        If SerialPort1.CtsHolding Then
            NewPTT = True
        Else
            NewPTT = False
        End If

        If NewPTT <> PTTState Then

            PTTState = NewPTT

            If PTTState Then
                SetPTT(PTTState)
                TX.Visible = True
                RX.Visible = False
            Else
                TX.Visible = False
                RX.Visible = True
                SetPTT(PTTState)
            End If

        End If

    End Sub


    Private Sub SerialPort2_PinChanged(ByVal sender As Object, ByVal e As System.IO.Ports.SerialPinChangedEventArgs) Handles SerialPort2.PinChanged

        Dim NewPTT As Boolean

        If SerialPort2.CtsHolding Then
            NewPTT = True
        Else
            NewPTT = False
        End If

        If NewPTT <> PTTState Then

            PTTState = NewPTT

            If PTTState Then
                SetPTT(PTTState)
                TX2.Visible = True
                RX2.Visible = False
            Else
                TX2.Visible = False
                RX2.Visible = True
                SetPTT(PTTState)
            End If
        End If
    End Sub

    Private Sub SerialPort3_PinChanged(ByVal sender As Object, ByVal e As System.IO.Ports.SerialPinChangedEventArgs) Handles SerialPort3.PinChanged

        Dim NewPTT As Boolean

        If SerialPort3.CtsHolding Then
            NewPTT = True
        Else
            NewPTT = False
        End If

        If NewPTT <> PTTState Then

            PTTState = NewPTT

            If PTTState Then
                SetPTT(PTTState)
                TX3.Visible = True
                RX3.Visible = False
            Else
                TX3.Visible = False
                RX3.Visible = True
                SetPTT(PTTState)
            End If
        End If
    End Sub

    Private Sub SerialPort4_PinChanged(ByVal sender As Object, ByVal e As System.IO.Ports.SerialPinChangedEventArgs) Handles SerialPort4.PinChanged

        Dim NewPTT As Boolean

        If SerialPort4.CtsHolding Then
            NewPTT = True
        Else
            NewPTT = False
        End If

        If NewPTT <> PTTState Then

            PTTState = NewPTT

            If PTTState Then
                SetPTT(PTTState)
                TX4.Visible = True
                RX4.Visible = False
            Else
                TX4.Visible = False
                RX4.Visible = True
                SetPTT(PTTState)
            End If
        End If
    End Sub
    Private Sub SetPTT(ByVal State As Integer)

        If CatPort.PortName = "CM108" Then

            If _device Is Nothing Then Exit Sub

            If State Then
                State = 1
            Else
                State = 0
            End If

            info(3) = State << (3 - 1)
            _device.Write(info)

            Exit Sub
        End If

        If CatPort.IsOpen Then

            If State Then
                CatPort.Write(TXMsg, 0, 8)
            Else
                CatPort.Write(RXMsg, 0, 8)
            End If

        End If



    End Sub

End Class